package com.huiju.welcome.controller;

import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.utils.AliFaceUtils;
import com.huiju.welcome.utils.AliOSSUtils;
import com.huiju.welcome.utils.Encrypt;
import com.huiju.welcome.utils.TencentFaceUtils;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.http.HttpStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

/**
 * @author FXF
 * @date 2019-03-13
 */
@RestController
@RequestMapping("/")
public class ImgController {

	@Autowired
	TencentFaceUtils tencentFaceUtils;
	
	@Autowired
	private AliFaceUtils aliFaceUtils;

	@GetMapping("/face")
	public ResponseBean testUpload2Aliface() {
		try {
			return ResponseBean.success(aliFaceUtils.detectFace("https://estateagents.oss-cn-shanghai.aliyuncs.com/1562654830859-unknown.jpg"));
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ResponseBean.error("", 400);
	}
	
	@ApiOperation(value = "图片/视频上传以及获取url", notes = "图片/视频上传以及获取url")
	@PostMapping(value = "/uploadFile", consumes = "multipart/*", headers = "content-type=multipart/form-data")
	public ResponseBean uploadFile(@ApiParam(value = "uploadFile" ,required = true) MultipartFile uploadFile){
		String defaultUploadDir = "/";

		try {
			String img = AliOSSUtils.putObject(uploadFile, defaultUploadDir);
			return ResponseBean.success(img);
		} catch (IOException e) {
			return ResponseBean.error("上传图片失败: " + e.getMessage(), HttpStatus.SC_INTERNAL_SERVER_ERROR);
		}
	}

	@PostMapping("/miniapp/upload")
	public ResponseBean uploadImage(@RequestParam("file") MultipartFile multipartFile) {
		String defaultUploadDir = "/";

		try {
			String img = AliOSSUtils.putObject(multipartFile, defaultUploadDir);
			return ResponseBean.success(img);
		} catch (IOException e) {
			return ResponseBean.error("上传图片失败: " + e.getMessage(), HttpStatus.SC_INTERNAL_SERVER_ERROR);
		}
	}
}
